<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: verif_ehrhart.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>verif_ehrhart.c</h1><a href="verif__ehrhart_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*************************************************/</span>
<a name="l00002"></a>00002 <span class="comment">/*     verif_ehrhart.c                           */</span>
<a name="l00003"></a>00003 <span class="comment">/* program to compare effective number of points */</span>
<a name="l00004"></a>00004 <span class="comment">/* in a polytope with the corresponding          */</span>
<a name="l00005"></a>00005 <span class="comment">/* evaluation of the Ehrhart polynomial.         */</span>
<a name="l00006"></a>00006 <span class="comment">/* Parameters vary in range -RANGE to RANGE      */</span>
<a name="l00007"></a>00007 <span class="comment">/* (define below) by default.                    */</span>
<a name="l00008"></a>00008 <span class="comment">/* Can be overridden by specifying               */</span>
<a name="l00009"></a>00009 <span class="comment">/* -r&lt;RANGE&gt;, or -m&lt;min&gt; and -M&lt;max&gt;             */</span>
<a name="l00010"></a>00010 <span class="comment">/*                                               */</span>
<a name="l00011"></a>00011 <span class="comment">/* written by Vincent Loechner (c) 2000.         */</span>
<a name="l00012"></a>00012 <span class="comment">/*  loechner@icps.u-strasbg.fr                   */</span>
<a name="l00013"></a>00013 <span class="comment">/*************************************************/</span>
<a name="l00014"></a>00014 <span class="comment">/*</span>
<a name="l00015"></a>00015 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00018"></a>00018 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00019"></a>00019 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00020"></a>00020 <span class="comment">    (at your option) any later version.</span>
<a name="l00021"></a>00021 <span class="comment"></span>
<a name="l00022"></a>00022 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00023"></a>00023 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00024"></a>00024 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00025"></a>00025 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00026"></a>00026 <span class="comment"></span>
<a name="l00027"></a>00027 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00028"></a>00028 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00029"></a>00029 <span class="comment">*/</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00037"></a><a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">00037</a> <span class="preprocessor">#define MAXRAYS 1024</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="comment">/* define this to print all the results */</span>
<a name="l00040"></a>00040 <span class="comment">/* else, only a progress bar is printed */</span>
<a name="l00041"></a>00041 <span class="comment">/* #define PRINT_ALL_RESULTS     */</span>
<a name="l00042"></a>00042 <span class="comment">/* define this to continue the test after first error found */</span>
<a name="l00043"></a>00043 <span class="comment">/* #define DONT_BREAK_ON_ERROR */</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">/* RANGE : normal range for evalutations (-RANGE -&gt; RANGE) */</span>
<a name="l00046"></a><a class="code" href="verif__ehrhart_8c.html#ac04dd0afaf7ea3eb2ade2544d2d5f907">00046</a> <span class="preprocessor">#define RANGE 50</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 <span class="comment">/* SRANGE : small range for evalutations */</span>
<a name="l00049"></a><a class="code" href="verif__ehrhart_8c.html#a0529c3d24b479e7b3421e2ed293aa197">00049</a> <span class="preprocessor">#define SRANGE 15</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="comment">/* if dimension &gt;= BIDDIM, use SRANGE */</span>
<a name="l00052"></a><a class="code" href="verif__ehrhart_8c.html#a8280de28f23f81d202ac9b2436ac0eb8">00052</a> <span class="preprocessor">#define BIGDIM 5</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 <span class="comment">/* VSRANGE : very small range for evalutations */</span>
<a name="l00055"></a><a class="code" href="verif__ehrhart_8c.html#a387713ee70775fb2114973c6212a1c42">00055</a> <span class="preprocessor">#define VSRANGE 5</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>
<a name="l00057"></a>00057 <span class="comment">/* if dimension &gt;= VBIDDIM, use VSRANGE */</span>
<a name="l00058"></a><a class="code" href="verif__ehrhart_8c.html#a4417e623e485f606d7b344cf34aa7ecb">00058</a> <span class="preprocessor">#define VBIGDIM 8</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a><a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">00060</a> Value <a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>, <a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#ifdef DONT_BREAK_ON_ERROR</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#define PRINT_ALL_RESULTS</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00066"></a>00066 <span class="preprocessor">#ifndef PRINT_ALL_RESULTS</span>
<a name="l00067"></a><a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">00067</a> <span class="preprocessor"></span><span class="keywordtype">int</span> <a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">st</a>;
<a name="l00068"></a>00068 <span class="preprocessor">#endif</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>
<a name="l00070"></a>00070 <span class="comment">/****************************************************/</span>
<a name="l00071"></a>00071 <span class="comment">/* function check_poly :                            */</span>
<a name="l00072"></a>00072 <span class="comment">/* scans the parameter space from min to max (all   */</span>
<a name="l00073"></a>00073 <span class="comment">/* directions). Computes the number of points in    */</span>
<a name="l00074"></a>00074 <span class="comment">/* the polytope using both methods, and compare them*/</span>
<a name="l00075"></a>00075 <span class="comment">/* returns 1 on success                             */</span>
<a name="l00076"></a>00076 <span class="comment">/****************************************************/</span>
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="verif__ehrhart_8c.html#adc96f6810690bdfed45afff2739f93ee">00078</a> <span class="keywordtype">int</span> <a class="code" href="verif__ehrhart_8c.html#adc96f6810690bdfed45afff2739f93ee">check_poly</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *S,<a class="code" href="structpolyhedron.html">Polyhedron</a> *C,<a class="code" href="struct__enumeration.html">Enumeration</a> *en,
<a name="l00079"></a>00079                <span class="keywordtype">int</span> nparam,<span class="keywordtype">int</span> pos,Value *z) {
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordtype">int</span> cc,k;
<a name="l00082"></a>00082   Value c,tmp,*ctmp;
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(c); <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(tmp);
<a name="l00085"></a>00085   
<a name="l00086"></a>00086   <span class="keywordflow">if</span>(pos == nparam) {
<a name="l00087"></a>00087     
<a name="l00088"></a>00088     <span class="comment">/* Computes the ehrhart polynomial */</span>
<a name="l00089"></a>00089     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(c,*(ctmp=<a class="code" href="eval__ehrhart_8c.html#af970e7f69cbf548188a8f3754001a150">compute_poly</a>(en,&amp;z[S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+1])));
<a name="l00090"></a>00090     free(ctmp);
<a name="l00091"></a>00091     <span class="comment">/* if c=0 we may be out of context. */</span>
<a name="l00092"></a>00092     <span class="comment">/* scanning is useless in this case*/</span>
<a name="l00093"></a>00093     <span class="keywordflow">if</span>(!<a class="code" href="eval__ehrhart_8c.html#aeaa7a17d905454d792bc8bb5409f941d">in_domain</a>(C,&amp;z[S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+1])) {
<a name="l00094"></a>00094    
<a name="l00095"></a>00095       <span class="comment">/* ok */</span> ;
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097     <span class="keywordflow">else</span> {
<a name="l00098"></a>00098       
<a name="l00099"></a>00099 <span class="preprocessor">#ifdef PRINT_ALL_RESULTS</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>      printf(<span class="stringliteral">&quot;EP( &quot;</span>);
<a name="l00101"></a>00101       <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,z[S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+1]);
<a name="l00102"></a>00102       <span class="keywordflow">for</span>(k=S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+2;k&lt;=S-&gt;Dimension;++k) {
<a name="l00103"></a>00103         printf(<span class="stringliteral">&quot;, &quot;</span>);
<a name="l00104"></a>00104         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,z[k]);
<a name="l00105"></a>00105       }
<a name="l00106"></a>00106       printf(<span class="stringliteral">&quot; ) = &quot;</span>);
<a name="l00107"></a>00107       <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,c);
<a name="l00108"></a>00108       printf(<span class="stringliteral">&quot; &quot;</span>);
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111       <span class="comment">/* Count manually the number of points */</span>
<a name="l00112"></a>00112       <a class="code" href="ehrhart_8c.html#adfc5a48cdab1ce4848c8f03a2707dcf9" title="PROCEDURES TO COMPUTE ENUMERATION.">count_points</a>(1,S,z,&amp;tmp);
<a name="l00113"></a>00113 <span class="preprocessor">#ifdef PRINT_ALL_RESULTS</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>        printf(<span class="stringliteral">&quot;, count = &quot;</span>);
<a name="l00115"></a>00115         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stdout, <a class="code" href="types_8h.html#ae6f16bcd4a42ba51cbb003e3d1e1cde6">P_VALUE_FMT</a>, tmp);
<a name="l00116"></a>00116         printf(<span class="stringliteral">&quot;. &quot;</span>);
<a name="l00117"></a>00117 <span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119       <span class="keywordflow">if</span>(<a class="code" href="source_2arith_2arithmetique_8h.html#a8092395b58522bbac9f2c8a1ee14c10c">value_ne</a>(tmp,c)) {
<a name="l00120"></a>00120         printf(<span class="stringliteral">&quot;\n&quot;</span>); 
<a name="l00121"></a>00121         fflush(stdout);
<a name="l00122"></a>00122         fprintf(stderr,<span class="stringliteral">&quot;Error !\n&quot;</span>);
<a name="l00123"></a>00123         fprintf(stderr,<span class="stringliteral">&quot;EP( &quot;</span>);
<a name="l00124"></a>00124         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stderr,VALUE_FMT,z[S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+1]);
<a name="l00125"></a>00125         <span class="keywordflow">for</span>(k=S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+2;k&lt;=S-&gt;Dimension;++k) {
<a name="l00126"></a>00126           fprintf(stderr,<span class="stringliteral">&quot;, &quot;</span>);
<a name="l00127"></a>00127           <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stderr,VALUE_FMT,z[k]);
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129         fprintf(stderr,<span class="stringliteral">&quot; ) should be &quot;</span>);
<a name="l00130"></a>00130         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stderr,VALUE_FMT,tmp);
<a name="l00131"></a>00131         fprintf(stderr,<span class="stringliteral">&quot;, while EP eval gives &quot;</span>);
<a name="l00132"></a>00132         <a class="code" href="source_2arith_2arithmetique_8h.html#ad34605b56b571830b928b50a74d618b7">value_print</a>(stderr,VALUE_FMT,c);
<a name="l00133"></a>00133         fprintf(stderr,<span class="stringliteral">&quot;.\n&quot;</span>);
<a name="l00134"></a>00134 <span class="preprocessor">#ifndef DONT_BREAK_ON_ERROR</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>        <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(c); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00136"></a>00136         <span class="keywordflow">return</span>(0);
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>      }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#ifdef PRINT_ALL_RESULTS</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>      <span class="keywordflow">else</span>
<a name="l00142"></a>00142         printf(<span class="stringliteral">&quot;OK.\n&quot;</span>);
<a name="l00143"></a>00143 <span class="preprocessor">#endif</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>    }
<a name="l00145"></a>00145   }
<a name="l00146"></a>00146   <span class="keywordflow">else</span>
<a name="l00147"></a>00147     <span class="keywordflow">for</span>(<a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(tmp,<a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>); <a class="code" href="source_2arith_2arithmetique_8h.html#a47975ace017981602e1064f98f43f8a7">value_le</a>(tmp,<a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>); <a class="code" href="source_2arith_2arithmetique_8h.html#a88693f35dd41deddc6ac0700073fc8db">value_increment</a>(tmp,tmp)) {
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="preprocessor">#ifndef PRINT_ALL_RESULTS</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>      k = VALUE_TO_INT(tmp);
<a name="l00151"></a>00151       <span class="keywordflow">if</span>(!pos &amp;&amp; !(k%<a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">st</a>)) {
<a name="l00152"></a>00152         printf(<span class="stringliteral">&quot;o&quot;</span>);
<a name="l00153"></a>00153         fflush(stdout);
<a name="l00154"></a>00154       }
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>      
<a name="l00157"></a>00157       <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(z[pos+S-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>-nparam+1],tmp);
<a name="l00158"></a>00158       <span class="keywordflow">if</span>(!<a class="code" href="verif__ehrhart_8c.html#adc96f6810690bdfed45afff2739f93ee">check_poly</a>(S,C,en,nparam,pos+1,z)) {
<a name="l00159"></a>00159         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(c); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00160"></a>00160         <span class="keywordflow">return</span>(0);
<a name="l00161"></a>00161       }
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(c); <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00164"></a>00164   <span class="keywordflow">return</span>(1);
<a name="l00165"></a>00165 } <span class="comment">/* check_poly */</span>
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="verif__ehrhart_8c.html#a0ddf1224851353fc92bfbff6f499fa97">00167</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a>(<span class="keywordtype">int</span> argc,<span class="keywordtype">char</span> *argv[]) {
<a name="l00168"></a>00168         
<a name="l00169"></a>00169   <a class="code" href="structmatrix.html">Matrix</a> *C1, *P1;
<a name="l00170"></a>00170   <a class="code" href="structpolyhedron.html">Polyhedron</a> *C, *P, *S;
<a name="l00171"></a>00171   <a class="code" href="structpolyhedron.html">Polyhedron</a> *CC, *PP;
<a name="l00172"></a>00172   <a class="code" href="struct__enumeration.html">Enumeration</a> *en;
<a name="l00173"></a>00173   Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, tmp;
<a name="l00174"></a>00174   <span class="keywordtype">int</span> i,j;
<a name="l00175"></a>00175   <span class="keywordtype">int</span> <a class="code" href="polyparam_8c.html#a742204794ea328ba293fe59cec79b990">m</a>,M;
<a name="l00176"></a>00176   
<a name="l00177"></a>00177 <span class="comment">/******* Read the input *********/</span>
<a name="l00178"></a>00178   P1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00179"></a>00179   C1 = <a class="code" href="matrix_8c.html#a3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="keywordflow">if</span>(C1-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a> &lt; 2) {
<a name="l00182"></a>00182     fprintf(stderr,<span class="stringliteral">&quot;Not enough parameters !\n&quot;</span>);
<a name="l00183"></a>00183     exit(0);
<a name="l00184"></a>00184   }
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   P = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(P1,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00187"></a>00187   C = <a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(C1,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00188"></a>00188   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C1);
<a name="l00189"></a>00189   <a class="code" href="matrix_8c.html#afcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(P1);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">/******* Read the options: initialize min and max ********/</span>
<a name="l00192"></a>00192   <span class="keywordflow">if</span>(P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> &gt;= <a class="code" href="verif__ehrhart_8c.html#a4417e623e485f606d7b344cf34aa7ecb">VBIGDIM</a>)
<a name="l00193"></a>00193     M = <a class="code" href="verif__ehrhart_8c.html#a387713ee70775fb2114973c6212a1c42">VSRANGE</a>;
<a name="l00194"></a>00194   <span class="keywordflow">else</span> <span class="keywordflow">if</span>(P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> &gt;= <a class="code" href="verif__ehrhart_8c.html#a8280de28f23f81d202ac9b2436ac0eb8">BIGDIM</a>)
<a name="l00195"></a>00195     M = <a class="code" href="verif__ehrhart_8c.html#a0529c3d24b479e7b3421e2ed293aa197">SRANGE</a>;
<a name="l00196"></a>00196   <span class="keywordflow">else</span>
<a name="l00197"></a>00197     M = <a class="code" href="verif__ehrhart_8c.html#ac04dd0afaf7ea3eb2ade2544d2d5f907">RANGE</a>;
<a name="l00198"></a>00198   m = -M;
<a name="l00199"></a>00199   <span class="keywordflow">if</span>(argc != 1 ) {
<a name="l00200"></a>00200     <span class="keywordflow">for</span>(i=1;i&lt;argc;i++) {
<a name="l00201"></a>00201       <span class="keywordflow">if</span>(!strncmp(argv[i],<span class="stringliteral">&quot;-m&quot;</span>,2)) {
<a name="l00202"></a>00202         
<a name="l00203"></a>00203         <span class="comment">/* min specified */</span>
<a name="l00204"></a>00204         m = atoi(&amp;argv[i][2]);
<a name="l00205"></a>00205       }
<a name="l00206"></a>00206       <span class="keywordflow">else</span> <span class="keywordflow">if</span>(!strncmp(argv[i],<span class="stringliteral">&quot;-M&quot;</span>,2)) {
<a name="l00207"></a>00207         
<a name="l00208"></a>00208         <span class="comment">/* max specified */</span>
<a name="l00209"></a>00209         M = atoi(&amp;argv[i][2]);
<a name="l00210"></a>00210       }
<a name="l00211"></a>00211       <span class="keywordflow">else</span> <span class="keywordflow">if</span>(!strncmp(argv[i], <span class="stringliteral">&quot;-r&quot;</span>, 2)) {
<a name="l00212"></a>00212         
<a name="l00213"></a>00213         <span class="comment">/* range specified */</span>
<a name="l00214"></a>00214         M = atoi(&amp;argv[i][2]);
<a name="l00215"></a>00215         m = -M;
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217       <span class="keywordflow">else</span> {
<a name="l00218"></a>00218         fprintf(stderr,<span class="stringliteral">&quot;Unknown option: %s\n&quot;</span>,argv[i]);
<a name="l00219"></a>00219         fprintf(stderr,<span class="stringliteral">&quot;Usage: %s [-m&lt;&gt;][-M&lt;&gt;][-r&lt;&gt;]\n&quot;</span>,argv[0]);
<a name="l00220"></a>00220         <span class="keywordflow">return</span>(-1);
<a name="l00221"></a>00221       }
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223   }
<a name="l00224"></a>00224   <span class="keywordflow">if</span>(m &gt; M) {
<a name="l00225"></a>00225     fprintf(stderr,<span class="stringliteral">&quot;Nothing to do: min &gt; max !\n&quot;</span>);
<a name="l00226"></a>00226     <span class="keywordflow">return</span>(0);
<a name="l00227"></a>00227   }
<a name="l00228"></a>00228   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(<a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>);
<a name="l00229"></a>00229   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(<a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>);
<a name="l00230"></a>00230   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(<a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>,m);
<a name="l00231"></a>00231   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(<a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>,M);
<a name="l00232"></a>00232   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(tmp);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="comment">/******* Compute true context *******/</span>
<a name="l00235"></a>00235   CC = <a class="code" href="polyhedron_8c.html#affd77db2a2f748d557ab6be0fcede209">align_context</a>(C,P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00236"></a>00236   PP = <a class="code" href="polyhedron_8c.html#ac5a1a2751f0b833183560af25b18033b">DomainIntersection</a>(P,CC,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00237"></a>00237   <a class="code" href="polyhedron_8c.html#ae6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(CC);
<a name="l00238"></a>00238   C1 = <a class="code" href="matrix_8c.html#ac0b29e1d99a2823ad00b5f2157879d80">Matrix_Alloc</a>(C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1,P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="keywordflow">for</span>(i=0;i&lt;C1-&gt;<a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>;i++)
<a name="l00241"></a>00241     <span class="keywordflow">for</span>(j=0;j&lt;C1-&gt;<a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>;j++)
<a name="l00242"></a>00242       <span class="keywordflow">if</span>(i==j-P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>)
<a name="l00243"></a>00243         <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(C1-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],1);
<a name="l00244"></a>00244       <span class="keywordflow">else</span>
<a name="l00245"></a>00245         <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(C1-&gt;<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>[i][j],0);
<a name="l00246"></a>00246   CC = <a class="code" href="polyhedron_8c.html#a0b1d25597364fcc0847e8de25d9454c4">Polyhedron_Image</a>(PP,C1,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00247"></a>00247   <a class="code" href="polyhedron_8c.html#ae6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a>(C);
<a name="l00248"></a>00248   C = CC;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">/******* Compute EP *********/</span>
<a name="l00251"></a>00251   en = <a class="code" href="ehrhart_8c.html#a3c3e442b1d2c924f03f02f9e9283141a" title="Procedure to count points in a parameterized polytope.">Polyhedron_Enumerate</a>(P,C,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>,NULL);
<a name="l00252"></a>00252   
<a name="l00253"></a>00253   <span class="comment">/******* Initializations for check *********/</span>
<a name="l00254"></a>00254   p = (Value *)malloc(<span class="keyword">sizeof</span>(Value) * (P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+2));
<a name="l00255"></a>00255   <span class="keywordflow">for</span>(i=0;i&lt;=P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>;i++) {
<a name="l00256"></a>00256     <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(p[i]);
<a name="l00257"></a>00257     <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(p[i],0);
<a name="l00258"></a>00258   }
<a name="l00259"></a>00259   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(p[i]);
<a name="l00260"></a>00260   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(p[i],1);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">/* S = scanning list of polyhedra */</span>
<a name="l00263"></a>00263   S = <a class="code" href="polyhedron_8c.html#a7e6c09758e3d3063be1386c7026b38ba">Polyhedron_Scan</a>(P,C,<a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="preprocessor">#ifndef PRINT_ALL_RESULTS</span>
<a name="l00266"></a>00266 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a> &gt; 0) {
<a name="l00267"></a>00267     <a class="code" href="source_2arith_2arithmetique_8h.html#ae92a58eee3b6f5c6a99e6837e68407e1">value_subtract</a>(tmp,<a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>,<a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>);
<a name="l00268"></a>00268     <span class="keywordflow">if</span> (VALUE_TO_INT(tmp) &gt; 80)
<a name="l00269"></a>00269       <a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">st</a> = 1+(VALUE_TO_INT(tmp))/80;
<a name="l00270"></a>00270     <span class="keywordflow">else</span>
<a name="l00271"></a>00271       <a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">st</a>=1;
<a name="l00272"></a>00272     <span class="keywordflow">for</span>(i=VALUE_TO_INT(<a class="code" href="verif__ehrhart_8c.html#a1c0ed9242a98f138b59c76f8454cfaa6">min</a>);i&lt;=VALUE_TO_INT(<a class="code" href="verif__ehrhart_8c.html#a76af106aaa860ca001b28491fa8e046c">max</a>);i+=<a class="code" href="verif__ehrhart_8c.html#a35b567772b277e799ec7be04de19b2e7">st</a>)
<a name="l00273"></a>00273       printf(<span class="stringliteral">&quot;.&quot;</span>);
<a name="l00274"></a>00274     printf( <span class="stringliteral">&quot;\r&quot;</span> );
<a name="l00275"></a>00275     fflush(stdout);
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277 <span class="preprocessor">#endif</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279   <span class="comment">/******* CHECK NOW *********/</span>
<a name="l00280"></a>00280   <span class="keywordflow">if</span>(S &amp;&amp; !<a class="code" href="verif__ehrhart_8c.html#adc96f6810690bdfed45afff2739f93ee">check_poly</a>(S,C,en,C-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>,0,p)) {
<a name="l00281"></a>00281     fprintf(stderr,<span class="stringliteral">&quot;Check failed !\n&quot;</span>);
<a name="l00282"></a>00282     <span class="keywordflow">for</span>(i=0;i&lt;=(P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1);i++) 
<a name="l00283"></a>00283       <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(p[i]);
<a name="l00284"></a>00284     <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);  
<a name="l00285"></a>00285     <span class="keywordflow">return</span>(-1);
<a name="l00286"></a>00286   }
<a name="l00287"></a>00287     
<a name="l00288"></a>00288 <span class="preprocessor">#ifndef PRINT_ALL_RESULTS</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span>  printf( <span class="stringliteral">&quot;\n&quot;</span> );
<a name="l00290"></a>00290 <span class="preprocessor">#endif</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>  
<a name="l00292"></a>00292   <span class="keywordflow">for</span>(i=0;i&lt;=(P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1);i++) 
<a name="l00293"></a>00293     <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(p[i]);
<a name="l00294"></a>00294   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(tmp);
<a name="l00295"></a>00295   <span class="keywordflow">return</span>(0);
<a name="l00296"></a>00296 } <span class="comment">/* main */</span>
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
